#include <stdio.h>
#include <stdlib.h>

int verbose = 0;
int count = 0;

void pp(FILE *fp,int *cols,int nrows,int n) {
  for (int i = 0; i < nrows; i++) {
    for (int j = 0; j < n; j++)
      fputc(j == cols[i] ? 'Q' : '.',fp);
    fputc('\n',fp) ;
  }
}

inline static int attack(int i, int row, int *cols) {
  for (int j = 0 ; j < row ; j++) {
    int cj = cols[j] ;
    if (cj == i || abs(cj-i) == row-j) return 1 ;
  }
  return 0;
}

void solve(int n, int row, int *cols) {
  if (row == n) {
    ++count ;
    if (verbose) {
      printf("\nNo. %d\n-----\n", count);
      pp(stdout,cols,n,n) ;
    }
    return;
  }
 
  for (int i = 0; i < n; i++) {
    if (!attack(i,row,cols)) { 
      cols[row] = i;
      if (verbose > 1) {
        fprintf(stderr,"** row=%i\n",row) ;
        pp(stderr,cols,row+1,n) ;    
        fprintf(stderr,"\n") ;
      }
      solve(n, row + 1, cols);
    }
  }
}

void usage(char *pgm)
{
  fprintf(stderr,"usage: %s [-v]* n\n",pgm);
  exit(-1);
}

int main(int argc, char **argv) {
  char *pgm = argv[0];
  char *arg=0;
  int n = 8 ;

  while (--argc) {
    arg = *++argv;
    if (*arg == '-') {
      arg++ ;
      if (*arg == 'v') {
         verbose++;
      } else
        usage(pgm);
    } else {
      break;
    }
  }

  if (argc >= 1) n = atoi(arg);
  int cols[n];
  solve(n, 0, cols);
  printf("%i\n",count);
}
